﻿Imports Microsoft.Win32.SafeHandles
Imports System.Text
Imports System.Diagnostics.FileVersionInfo
Imports System.Runtime.InteropServices

Module Module1

    Public Const INVALID_HANDLE_VALUE = -1

    '   Windows APIの定義
    Public Declare Function Wow64DisableWow64FsRedirection Lib "kernel32" (ByRef oldvalue As Long) As Boolean
    Public Declare Function Wow64RevertWow64FsRedirection Lib "kernel32" (ByVal oldvalue As Long) As Boolean
    Public Declare Function timeGetTime Lib "winmm.dll" () As Long

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GetLastError() As Integer
    end function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalAlloc(ByVal uFlags As Integer, ByVal dwBytes As Integer) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalFree(ByVal handle As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalLock(ByVal handle As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, ExactSpelling:=True)>
    Public Function GlobalUnlock(ByVal handle As IntPtr) As Boolean
    End Function

    <DllImport("kernel32.dll", SetLastError:=True, CharSet:=CharSet.Unicode)>
    Public Function CreateFile(ByVal lpFileName As String, ByVal dwDesiredAccess As System.UInt32, ByVal dwShareMode As System.UInt32, ByVal lpSecurityAttributes As IntPtr, ByVal dwCreationDisposition As System.UInt32, ByVal dwFlagsAndAttributes As System.UInt32, ByVal hTemplateFile As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True, ExactSpelling:=True)>
    Public Function CloseHandle(ByVal hObject As IntPtr) As Integer
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True, ExactSpelling:=True)>
    Public Function WriteFile(ByVal hFile As Long, ByRef lpBuffer As Long, ByVal nNumberOfBytesToWrite As Integer, ByRef lpNumberOfBytesWritten As Integer, ByRef lpOverlapped As Integer) As Boolean
    End Function

    Public Const GMEM_FIXED = &H0
    Public Const GMEM_ZEROINIT = &H40
    Public Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)
    Public Const FILE_ATTRIBUTE_NORMAL As Short = &H80
    Public Const GENERIC_READ As Long = &H80000000
    Public Const GENERIC_WRITE As UInteger = &H40000000
    Public Const CREATE_NEW As UInteger = 1
    Public Const CREATE_ALWAYS As UInteger = 2
    Public Const OPEN_EXISTING As UInteger = 3



    '   WinUSB関連
    <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=True)>
    Public Function RegisterDeviceNotification(ByVal hRecipient As IntPtr, ByVal NotificationFilter As IntPtr, ByVal Flags As Integer) As IntPtr
    End Function

    <StructLayout(LayoutKind.Sequential)>
    Public Class DEV_BROADCAST_DEVICEINTERFACE
        Friend dbcc_size As Integer
        Friend dbcc_devicetype As Integer
        Friend dbcc_reserved As Integer
        'Friend dbcc_classguid As Guid
        Friend dbcc_handle As Integer
        Friend dbcc_name As Short
    End Class

    <StructLayout(LayoutKind.Sequential)>
    Friend Class DEV_BROADCAST_HDR
        Friend dbch_size As Integer
        Friend dbch_devicetype As Integer
        Friend dbch_reserved As Integer
    End Class

    Public Const DBT_DEVTYP_DEVICEINTERFACE As Integer = 5
    Public Const DEVICE_NOTIFY_WINDOW_HANDLE As Integer = 0
    Public Const DBT_DEVICEREMOVECOMPLETE As Integer = &H8004
    Public Const DBT_DEVICEARRIVAL As Integer = &H8000

    '   --------------------------------------------------------------------------------
    '   ﾛｸﾞ用関数
    Public Sub LOG_PRINT(ByVal msg As String)

        Dim Now As DateTime = DateTime.Now
        LOGForm.RichTextBox1.AppendText("【" & Now & "】 " & msg & vbCrLf)

    End Sub

    '   --------------------------------------------------------------------------------
    '   WinUSBﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝの取得
    Public Sub GetVer()

        Dim VerInfo As FileVersionInfo
        Dim handle As IntPtr

        '   ﾄﾞﾗｲﾊﾞﾍのﾘﾀﾞｲﾚｸﾄを禁止
        Wow64DisableWow64FsRedirection(handle)

        Try
            VerInfo = FileVersionInfo.GetVersionInfo(Environment.SystemDirectory + "\drivers\winusb.sys")
        Catch ex As Exception

            MsgBox("ﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝの取得に失敗しました。")
            Exit Sub

        End Try

        LOG_PRINT("winusb.sys = Ver" & VerInfo.FileVersion.ToString)

    End Sub

    '   --------------------------------------------------------------------------------
    '   各種ｺﾝﾎﾟｰﾈﾝﾄの切り替え
    Public Sub Component_Change(ByVal sel As Boolean)

        '   ﾚｼﾞｽﾀ操作TAB
        MainForm.NumericUpDown1.Enabled = sel
        MainForm.NumericUpDown2.Enabled = sel
        MainForm.NumericUpDown3.Enabled = sel
        MainForm.ComboBox1.Enabled = sel
        MainForm.ComboBox2.Enabled = sel
        MainForm.ComboBox3.Enabled = sel
        MainForm.TextBox1.Enabled = sel
        MainForm.TextBox2.Enabled = sel
        MainForm.TextBox3.Enabled = sel
        MainForm.MaskedTextBox1.Enabled = sel
        MainForm.MaskedTextBox2.Enabled = sel
        MainForm.MaskedTextBox3.Enabled = sel
        MainForm.Button3.Enabled = sel
        MainForm.Button4.Enabled = sel
        MainForm.Button5.Enabled = sel
        MainForm.Button6.Enabled = sel
        MainForm.Button7.Enabled = sel
        MainForm.Button8.Enabled = sel

        '   ﾒﾓﾘ操作TAB
        MainForm.TextBox4.Enabled = sel
        MainForm.TextBox5.Enabled = sel
        MainForm.TextBox6.Enabled = sel
        MainForm.TextBox7.Enabled = sel
        MainForm.ComboBox4.Enabled = sel
        MainForm.Button9.Enabled = sel
        MainForm.Button10.Enabled = sel
        MainForm.Button11.Enabled = sel
        MainForm.Button12.Enabled = sel
        MainForm.Button13.Enabled = sel
        MainForm.Button14.Enabled = sel

        '   USBｺﾝﾌｨｸﾞTAB
        MainForm.TextBox8.Enabled = sel
        MainForm.CheckBox1.Enabled = sel

        MainForm.Button15.Enabled = sel
        MainForm.Button16.Enabled = sel

        '   ﾎﾞｰﾄﾞ情報TAB
        MainForm.Button18.Enabled = sel

        '   ﾒｲﾝﾒﾆｭｰ


    End Sub

    '   --------------------------------------------------------------------------------
    '   ﾚｼﾞｽﾀﾘｰﾄﾞ処理
    Public Function gui_Reg_Read(ByVal hHandle As Integer, ByVal Adrs As UInteger, ByVal Width As UInteger, ByRef Rd As String) As Boolean

        Dim reg(8) As Byte

        Dim size As UInteger
        Dim rdtmp(8) As String
        Dim i As Short

        '   有効なﾊﾝﾄﾞﾙが指定されているか?
        If (hHandle = INVALID_HANDLE_VALUE) Then
            Return False
        End If

        '   ﾚｼﾞｽﾀﾚﾝｸﾞｽの処理
        Select Case Width

            Case 0  '   8bit
                size = SUSlv_RANGE_8BIT

            Case 1  '   16bit
                size = SUSlv_RANGE_16BIT

            Case 2  '   32bit
                size = SUSlv_RANGE_32BIT

            Case 3  '   64bit
                size = SUSlv_RANGE_64BIT

            Case Else   '   8bit
                size = SUSlv_RANGE_8BIT

        End Select




        '   ﾚｼﾞｽﾀﾘｰﾄﾞ処理(DLL関数ｺｰﾙ)
        If (SUSlv_Reg_Read(hHandle, Adrs, size, reg(0)) = False) Then
            MsgBox("DLL-RD処理の失敗")
            Return False
        End If

        If (size = SUSlv_RANGE_8BIT) Then
            rdtmp(0) = Convert.ToString(reg(0), 16)
            Rd = rdtmp(0)


        ElseIf (size = SUSlv_RANGE_16BIT) Then
            rdtmp(0) = Convert.ToString(reg(0), 16)
            rdtmp(1) = Convert.ToString(reg(1), 16)
            Rd = rdtmp(1) & rdtmp(0)

        ElseIf (size = SUSlv_RANGE_32BIT) Then
            rdtmp(0) = Convert.ToString(reg(0), 16)
            rdtmp(1) = Convert.ToString(reg(1), 16)
            rdtmp(2) = Convert.ToString(reg(2), 16)
            rdtmp(3) = Convert.ToString(reg(3), 16)
            Rd = rdtmp(3) & rdtmp(2) & rdtmp(1) & rdtmp(0)

        ElseIf (size = SUSlv_RANGE_64BIT) Then
            rdtmp(0) = Convert.ToString(reg(0), 16)
            rdtmp(1) = Convert.ToString(reg(1), 16)
            rdtmp(2) = Convert.ToString(reg(2), 16)
            rdtmp(3) = Convert.ToString(reg(3), 16)
            rdtmp(4) = Convert.ToString(reg(4), 16)
            rdtmp(5) = Convert.ToString(reg(5), 16)
            rdtmp(6) = Convert.ToString(reg(6), 16)
            rdtmp(7) = Convert.ToString(reg(7), 16)
            Rd = rdtmp(7) & rdtmp(6) & rdtmp(5) & rdtmp(4) & rdtmp(3) & rdtmp(2) & rdtmp(1) & rdtmp(0)

        End If



        Return True

    End Function

    '   --------------------------------------------------------------------------------
    '   ﾚｼﾞｽﾀﾗｲﾄ処理
    Public Function gui_Reg_Write(ByVal hHandle As Integer, ByVal Adrs As UInteger, ByVal Width As UInteger, ByRef WdText As String) As Boolean

        Dim reg(8) As Byte
        Dim hletter(8) As String
        Dim tmp As String
        Dim i As Int16

        Dim size As UInteger

        '   有効なﾊﾝﾄﾞﾙが指定されているか?
        If (hHandle = INVALID_HANDLE_VALUE) Then
            Return False
        End If

        '   ﾚｼﾞｽﾀﾚﾝｸﾞｽの処理
        Select Case Width

            Case 0  '   8bit
                size = SUSlv_RANGE_8BIT
                tmp = WdText.PadLeft(2, "0"c) '2桁表示に整形

            Case 1  '   16bit
                size = SUSlv_RANGE_16BIT
                tmp = WdText.PadLeft(4, "0"c)　'4桁表示に整形

            Case 2  '   32bit
                size = SUSlv_RANGE_32BIT
                tmp = WdText.PadLeft(8, "0"c)　'8桁表示に整形

            Case 3  '   64bit
                size = SUSlv_RANGE_64BIT
                tmp = WdText.PadLeft(16, "0"c)　'16桁表示に整形

            Case Else   '   8bit
                size = SUSlv_RANGE_8BIT
                tmp = WdText.PadLeft(2, "0"c)
        End Select

        If (size = SUSlv_RANGE_8BIT) Then
            hletter(0) = tmp.Substring(0, 2)

            '   ﾗｲﾄﾃﾞｰﾀ取得
            Try
                reg(0) = Byte.Parse(hletter(0), Globalization.NumberStyles.HexNumber)
            Catch ex As Exception
                Return False
            End Try


        ElseIf (size = SUSlv_RANGE_16BIT) Then
            hletter(0) = tmp.Substring(0, 2)
            hletter(1) = tmp.Substring(2, 2)

            Try
                reg(0) = Byte.Parse(hletter(1), Globalization.NumberStyles.HexNumber)
                reg(1) = Byte.Parse(hletter(0), Globalization.NumberStyles.HexNumber)
            Catch ex As Exception
                Return False
            End Try

        ElseIf (size = SUSlv_RANGE_32BIT) Then
            hletter(0) = tmp.Substring(0, 2)
            hletter(1) = tmp.Substring(2, 2)
            hletter(2) = tmp.Substring(4, 2)
            hletter(3) = tmp.Substring(6, 2)

            Try
                reg(0) = Byte.Parse(hletter(3), Globalization.NumberStyles.HexNumber)
                reg(1) = Byte.Parse(hletter(2), Globalization.NumberStyles.HexNumber)
                reg(2) = Byte.Parse(hletter(1), Globalization.NumberStyles.HexNumber)
                reg(3) = Byte.Parse(hletter(0), Globalization.NumberStyles.HexNumber)
            Catch ex As Exception
                Return False
            End Try

        ElseIf (size = SUSlv_RANGE_64BIT) Then
            hletter(0) = tmp.Substring(0, 2)
            hletter(1) = tmp.Substring(2, 2)
            hletter(2) = tmp.Substring(4, 2)
            hletter(3) = tmp.Substring(6, 2)
            hletter(4) = tmp.Substring(8, 2)
            hletter(5) = tmp.Substring(10, 2)
            hletter(6) = tmp.Substring(12, 2)
            hletter(7) = tmp.Substring(14, 2)

            Try
                reg(0) = Byte.Parse(hletter(7), Globalization.NumberStyles.HexNumber)
                reg(1) = Byte.Parse(hletter(6), Globalization.NumberStyles.HexNumber)
                reg(2) = Byte.Parse(hletter(5), Globalization.NumberStyles.HexNumber)
                reg(3) = Byte.Parse(hletter(4), Globalization.NumberStyles.HexNumber)
                reg(4) = Byte.Parse(hletter(3), Globalization.NumberStyles.HexNumber)
                reg(5) = Byte.Parse(hletter(2), Globalization.NumberStyles.HexNumber)
                reg(6) = Byte.Parse(hletter(1), Globalization.NumberStyles.HexNumber)
                reg(7) = Byte.Parse(hletter(0), Globalization.NumberStyles.HexNumber)
            Catch ex As Exception
                Return False
            End Try

        End If

        MsgBox(hletter(0))




        '   ﾚｼﾞｽﾀﾗｲﾄ処理(DLL関数ｺｰﾙ)
        If (SUSlv_Reg_Write(hHandle, Adrs, size, reg(0)) = False) Then
            MsgBox("DLL-WR処理の失敗")
            Return False
        End If



        Return True

    End Function

    '   USBｲﾍﾞﾝﾄ通知の設定
    Public Function RegisterForDeviceNotifications(ByVal formHandle As IntPtr, ByVal dWinUSBHandle As Integer, ByRef deviceNotificationHandle As IntPtr) As Boolean

        Dim devBroadcastDeviceInterface As DEV_BROADCAST_DEVICEINTERFACE = New DEV_BROADCAST_DEVICEINTERFACE()
        Dim devBroadcastDeviceInterfaceBuffer As IntPtr
        Dim size As Integer

        Try

            size = Marshal.SizeOf(devBroadcastDeviceInterface)
            devBroadcastDeviceInterface.dbcc_size = size
            devBroadcastDeviceInterface.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE
            devBroadcastDeviceInterface.dbcc_reserved = 0
            'devBroadcastDeviceInterface.dbcc_classguid = classGuid
            devBroadcastDeviceInterface.dbcc_handle = dWinUSBHandle
            devBroadcastDeviceInterfaceBuffer = Marshal.AllocHGlobal(size)
            Marshal.StructureToPtr(devBroadcastDeviceInterface, devBroadcastDeviceInterfaceBuffer, True)

            deviceNotificationHandle = RegisterDeviceNotification(formHandle, devBroadcastDeviceInterfaceBuffer, DEVICE_NOTIFY_WINDOW_HANDLE)
            Marshal.PtrToStructure(devBroadcastDeviceInterfaceBuffer, devBroadcastDeviceInterface)
            Marshal.FreeHGlobal(devBroadcastDeviceInterfaceBuffer)

            If (deviceNotificationHandle.ToInt32 = IntPtr.Zero.ToInt32) Then
                Return False
            Else
                Return True
            End If

        Catch ex As Exception
            Throw
        End Try
    End Function

End Module
